杭电oj HDOJ 1046 Gridland(最短路径)

杭电oj HDOJ 1046 Gridland

题目来源:http://acm.hdu.edu.cn/showproblem.php?pid=1046

Problem Description

For years, computer scientists have been trying to find efficient solutions to different computing problems. For some of them efficient algorithms are already available, these are the “easy” problems like sorting, evaluating a polynomial or finding the shortest path in a graph. For the “hard” ones only exponential-time algorithms are known. The traveling-salesman problem belongs to this latter group. Given a set of N towns and roads between these towns, the problem is to compute the shortest path allowing a salesman to visit each of the towns once and only once and return to the starting point.

The president of Gridland has hired you to design a program that calculates the length of the shortest traveling-salesman tour for the towns in the country. In Gridland, there is one town at each of the points of a rectangular grid. Roads run from every town in the directions North, Northwest, West, Southwest, South, Southeast, East, and Northeast, provided that there is a neighbouring town in that direction. The distance between neighbouring towns in directions North–South or East–West is 1 unit. The length of the roads is measured by the Euclidean distance. For example, Figure 7 shows 2 × 3-Gridland, i.e., a rectangular grid of dimensions 2 by 3. In 2 × 3-Gridland, the shortest tour has length 6.在这里插入图片描述

Input

The first line contains the number of scenarios.

For each scenario, the grid dimensions m and n will be given as two integer numbers in a single line, separated by a single blank, satisfying 1 < m < 50 and 1 < n < 50.

Output

The output for each scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1. In the next line, print the length of the shortest traveling-salesman tour rounded to two decimal digits. The output for every scenario ends with a blank line.

题目大意

测试用例给出村落整体的规格(有m行村落,每行有n个村落),要求求出从某一村庄出发,途径每一个村庄,最后回到该村庄的最短路径长度

题目大意

  1. 2 × 2 时 : 最 短 路 径 为 4 2\times2时:最短路径为4 2×24
    在这里插入图片描述
  2. 2 × 3 时 : 最 短 路 径 为 6 2\times3时:最短路径为6 2×36在这里插入图片描述
  3. 3 × 3 时 : 最 短 路 径 为 9.14 3\times3时:最短路径为9.14 3×39.14在这里插入图片描述

所以现在可以分为两种情况:

  1. 当m和n有至少一个偶数时,其最短路径的长度为 m × n m\times n m×n
  2. 否则其最短路径的长度为 m × n − 1 + 2 m\times n-1+\sqrt{2} m×n1+2

本人的C++解决方案

#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;

int main()
{
	int N, i, m, n, count = 1;
	double res;
	cin >> N;
	for (i = 0; i < N; i++) {
		cin >> m >> n;
		if (m % 2 && n % 2) {
			res = m * n - 1 + sqrt(2);
		}
		else {
			res = m * n;
		}
		cout << "Scenario #" << count++ << ":" << endl;
		// 注意:每个测试用例的输出后都需要“换行”,最后一个测试用例也要输出!
		cout << setiosflags(ios::fixed) << setprecision(2) << res << endl << endl;
	}
	return 0;
}

代码通过HDOJ平台运行检查,如发现错误,欢迎指出和纠正,谢谢!

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值